#include <amxmodx>
#include <amxmisc>
#include <dhudmessage>
#include <hamsandwich>

new g_kills[33] = {0,...};
new timekill[33] = {0,...};
new victims[33] = {0,...};
new kill_cvar

new const kill_sounds_1234[][] =
{
    "misc/firstkill.wav",
    "misc/doublekill.wav",
    "misc/triplekill.wav",
    "misc/multikill.wav"
}

new const kill_sounds[][] =
{
    "misc/revenge.wav",
    "misc/headshot.wav",
    "misc/humililation.wav",
    "misc/gotit.wav",
    "misc/ohno.wav"
}

new const red[] = { 0, 77, 125, 150, 149 }
new const green[] = { 0, 124, 150, 112, 83 }
new const blue[] = { 0, 148, 76, 70, 68 }

public plugin_init()
{
    register_plugin("[CSO LIKE] Effect Killer","1.0.2","RaZzoR")

    RegisterHam(Ham_Spawn, "player", "Spawn", 1)
    register_event("DeathMsg", "DeathMsg", "a")
    kill_cvar = register_cvar("cso_rs_kill", "10")   
}
  
public plugin_precache()
{
    for(new i = 0; i < sizeof kill_sounds_1234; i++) 
	precache_sound(kill_sounds_1234[i])

    for(new i = 0; i < sizeof kill_sounds; i++) 
	precache_sound(kill_sounds[i])
}

public Spawn(id)
    g_kills[id] = 0

public DeathMsg()
{
    new killer, victim, headshot, weapon[12];

    killer = read_data(1)
    victim = read_data(2)
    headshot = read_data(3)
    read_data(4, weapon, charsmax(weapon))

    if(victim == killer) return


    victims[victim] = killer

    new sec_c = get_systime()
    new timekill_cvar = kill_cvar
    
    new timeleft = sec_c - timekill[killer]
    timekill[killer] = sec_c
    if (timeleft <= timekill_cvar) g_kills[killer] += 1;
    else g_kills[killer] = 1;
    if (g_kills[killer] > 4) g_kills[killer] = 1

    new g_revenge = 0
    if (victim == victims[killer])
    {
        g_revenge = 1
        victims[killer] = 0
    }



    new check_sound
    if (g_revenge == 1)
    {
        set_dhudmessage(255, 102, 0, -1.0, 0.285, 0, 1.2, 1.0)
	show_dhudmessage(killer, "REVENGE") 

        client_cmd(killer, "spk ^"%s^"", kill_sounds[0])
    }

    else if(headshot)
    {
        set_dhudmessage(196, 91, 22, -1.0, 0.285, 0, 1.2, 1.0)
	show_dhudmessage(killer, "HEADSHOT") 

        if(g_kills[killer] == 1)
        {
            client_cmd(killer, "spk ^"%s^"", kill_sounds[1])
            check_sound = 1
        }
    }

    else if(equali(weapon,"knife"))
    {
        set_dhudmessage(196, 91, 22, -1.0, 0.285, 0, 1.2, 1.0)
	show_dhudmessage(killer, "KNIFE") 

        client_cmd(killer, "speak ^"%s^"", kill_sounds[2])

        if(g_kills[killer] == 1)
        {
            client_cmd(victim, "spk ^"%s^"", kill_sounds[4])
            check_sound = 1
        }
    }
    
    else if(equali(weapon,"grenade"))
    {
        set_dhudmessage(196, 91, 22, -1.0, 0.285, 0, 1.2, 1.0)
	show_dhudmessage(killer, "GRENADE") 

        if(g_kills[killer] == 1)
        {
            client_cmd(killer, "spk ^"%s^"", kill_sounds[3])
            check_sound = 1
        }
    }

    
    if(g_kills[killer] < 5)
    {
        if(check_sound != 1) client_cmd(killer, "spk ^"%s^"", kill_sounds_1234[g_kills[killer] - 1])

        set_dhudmessage(red[killer], green[killer], blue[killer], 0.46, 0.25, 0, 1.5, 2.5)
	show_dhudmessage(killer, "%i", g_kills[killer]) 

        set_dhudmessage(255, 255, 243, 0.48, 0.25, 0, 1.5, 2.5)
	show_dhudmessage(killer, "KILL!") 
    }
}